"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class TransactionStatus(object):
    """
    The transaction status:  * PENDING: a transaction in the queue pending
    to be processed * BLOCKED: a transaction already being processed *
    PROCESSING: a transaction being processed (normalised, lifted over
    and annotated) * PERSISTING: a transaction being persisted in the
    database * BLOCKED: a transaction already being processed * DONE:
    a transaction has been successfully processed * CANCELLING: a
    transaction is being rolled back * CANCELLED: a transaction has
    been rolled back * ERROR: erroneous transaction that cannot be
    processed, nor retried (this is caused by reported variants
    already in the database) * ROLLBACK_ERROR: a transaction failed to
    roll back (this may leave the database in an inconsistent state) *
    DELETED: a transaction has been deleted by a user (same effect as
    CANCELLED but user triggered)      The happy path is PENDING ->
    BLOCKED -> PROCESSING -> PERSISTING -> DONE
    """

    PENDING = "PENDING"
    BLOCKED = "BLOCKED"
    PROCESSING = "PROCESSING"
    PERSISTING = "PERSISTING"
    DONE = "DONE"
    CANCELLING = "CANCELLING"
    CANCELLED = "CANCELLED"
    ERROR = "ERROR"
    ROLLBACK_ERROR = "ROLLBACK_ERROR"
    DELETED = "DELETED"

    def __hash__(self):
        return str(self).__hash__()

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
